head	3.4;
access;
symbols;
locks;
comment	@ * @;


3.4
date	2011.05.21.10.59.13;	author Average;	state Exp;
branches;
next	3.3;

3.3
date	2011.05.19.15.15.06;	author Average;	state Exp;
branches;
next	3.2;

3.2
date	2011.05.19.15.10.25;	author Average;	state Exp;
branches;
next	3.1;

3.1
date	2011.05.19.14.27.17;	author Average;	state Exp;
branches;
next	;


desc
@@


3.4
log
@DOSvCIeBǉBvZԂɂ͉emF
@
text
@PROGRAM artify;
{$H+}
USES
os2def,os2base,os2pmapi,Widget,
SysUtils,Math,VPUtils,
uGetOpt,ArtUnit,MltUnit;

{$PMTYPE PM}

{$I artify.inc}

{$R artify.res}

CONST
    MainItem:ARRAY [0..3] OF ToolbarData=(
            (NuID:IDB_RUN     ;cText:' Run Filter '),
//            (NuID:IDB_FILEOPEN;cText:' Open existing file '),
  //          (NuID:IDB_FILESAVE;cText:' Save file '),
            (NuID:TB_SEPARATOR;cText:''),
            (NuID:IDB_EXIT    ;cText:' Exit Application'),

            (NuID:0)
      );

CONST
    SampleNum=16;

type
    BitmapFilterClass=Class
        Fx,Fy:integer;
        Scene:SceneClass;
        Camera:CameraRecord;
        ViewGraph:GraphDataClass;
        constructor Create(x,y:integer);virtual;
        FUNCTION CalcPixelColor(x,y:INTEGER):ColorType;
        procedure RunFilter;virtual;
    END;

    TGraphicPaneWindowClass=CLASS(TPaneWindowClass)
        isOnFilter:boolean;
        BitmapFilter:BitmapFilterClass;
        OpenFileName:String;
        constructor Create(AN:HAB);OverRide;
        FUNCTION PaneHandler(window:hwnd;
                             msg:ULong;
                             mp1,mp2:MParam):MResult;OverRide;

    END;

FUNCTION  Calc(GPW:POINTER ):LONGINT;
VAR
    BF:BitmapFilterClass;
BEGIN
    DosSetPriority( PRTYS_THREAD, PRTYC_IDLETIME, 16, 0 );
    BF:=BitmapFilterClass(GPW);
    BF.RunFilter;
END;

constructor BitmapFilterClass.Create(x,y:integer);
VAR
    RC:ColorType;
    S:SphereClass;
    CP:CheckedPlaneClass;
BEGIN
    ViewGraph:=GraphDataClass.Create;
    ViewGraph.SetupHeader(x,y);


    CameraLookat(  Camera,
                   CreateVector(2, 1.5, 5),   // _
                   CreateVector(0, 0, 0),     // _
                   CreateVector(-0.5, 1, 0),  // 
                   GradToRad(40),          // p
                   ViewGraph.Cx,
                   ViewGraph.Cy);

    Scene:=SceneClass.Create;

    S:=  SphereClass.Create(
            CreateVector(-2.1,0,0),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.1,0.9))
         );
    Scene.AddObj( S );

    S:=  SphereClass.Create(
            CreateVector(0,0,0),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.9,0.1))
         );
    S.Material.Reflection:=0.8;
    Scene.AddObj(S) ;

    S:=  SphereClass.Create(
            CreateVector(2.1,0,0),
            1,
            CreateMaterial(CreateSpectrum(0.1,0.9,0.9))
         );
    S.Material.refraction:=0.9;
    S.Material.RefractiveRate:=1.5;
    Scene.AddObj(S);

    CP:=CheckedPlaneClass.Create(
            CreateVector(0,-1,0),
            CreateVector(0,1,0),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.9,0.9)),
            CreateMaterial(CreateSpectrum(0.1,0.1,0.1))
        );
    Scene.AddObj(CP);


    Scene.AddLight(
        LightClass.Create(
            CreateVector(1000,1000,1000),
            CreateSpectrum(1e8,1e8,1e8)
        )
    );
end;



FUNCTION BitmapFilterClass.CalcPixelColor(x,y:INTEGER):ColorType;
VAR
    px,py:single;
    Ray:RayRecord;
    L,c:SpectrumRecord;
    i:integer;
BEGIN
    L := scene.Black;
    for i:=1 to SampleNum do begin
        px := random(1000)/1000.0;
        py := random(1000)/1000.0;
        Ray:=GetCameraRay(Camera,x+px,y+py);
        c := scene.trace(ray, 0);
    // [3] F𑫂킹
        L := SpecAdd(L,c);
    END;
  // [4] ςFԂ
    result:=SpecToColor(SpecScale(L,(1.0 / SampleNum) ));
END;


procedure BitmapFilterClass.RunFilter;
var
    Fx,Fy:integer;
begin
    FOR Fy:=0 TO ViewGraph.Cy-1 DO BEGIN
       IF Fy mod 30 =0 then
           WinPostMsg(ClientThreadWnd,WM_RePaint,mparam(0),mparam(0));

       FOR Fx:= 0 TO ViewGraph.Cx-1 DO BEGIN
           ViewGraph.SetPixel(Fx,Fy,CalcPixelColor(Fx,Fy));
       END;
    END;
    WinPostMsg(ClientThreadWnd,WM_EndThread,mparam(0),mparam(0));
end;



constructor TGraphicPaneWindowClass.Create(AN:HAB);
begin
    isOnFilter:=FALSE;
    BitmapFilter:=Nil;
    BitmapFilter:=BitmapFilterClass.Create(320,240);
    inherited Create(AN);
end;


FUNCTION TGraphicPaneWindowClass.PaneHandler(window:hwnd;
                     msg:ULong;
                     mp1,mp2:MParam):MResult;
var
    ps:hps;
    paintRect,CurRect:RectL;
    SaveFileName:String;
begin
    result:=0;
    case Msg of
        wm_Paint:begin
            WinQueryWindowRect(Window, CurRect);
            ps:= WinBeginPaint(window,NULLHANDLE,@@PaintRect);
            WinFillRect(ps,CurRect,clr_white);
            IF BitmapFilter<>Nil then
                    BitmapFilter.ViewGraph.DrawBitmap(CurRect,ps);
            WinEndPaint(ps);
        end;
        wm_RePaint:begin
            WinInvalidateRect(window,NIL,FALSE);
        end;
        wm_EndThread:begin
            DosKillThread(ArtfyThread);
            isOnFilter:=FALSE;
            WinInvalidateRect(window,NIL,FALSE);
        end;
        WM_COMMAND:BEGIN
            CASE SHORT1FROMMP(mp1) OF
                IDB_RUN:BEGIN
                    isOnFilter:=TRUE;
                    ClientThreadWnd:=window;
                    ArtfyThread:= VPBeginThread(Calc,5094000,BitmapFilter);
                END;
                IDB_EXIT:
                    WinPostMsg(Window, WM_QUIT, 0, 0);
            END;
        END;
        else
            result:=inherited PaneHandler(Window,msg,mp1,mp2);
    end;
end;

VAR
    habAnchor   : HAB;
    hmqQueue    : HMQ;
    qmMsg       : QMSG;
    PaneWindow:TGraphicPaneWindowClass;
    GetOpt:GetOptClass;
    OptStr:String;
    lWidth,lHeight:uLong;

BEGIN
    habAnchor := WinInitialize(0);
    hmqQueue := WinCreateMsgQueue(habAnchor, 0);

    PaneWindow:=TGraphicPaneWindowClass.Create(habAnchor);
 //   PaneWindow.CreateTab;
  //  PaneWindow.TabPane.AddTab('Tab',1);
    PaneWindow.CreateToolbar(@@MainItem);


   {************************************************************}
   {* get screen height and width                              *}
   {************************************************************}

   lWidth := WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);

   lHeight := WinQuerySysValue(HWND_DESKTOP,SV_CYSCREEN);

   {************************************************************}
   {* if failed, display error, and set to default value       *}
   {************************************************************}

   if ( lWidth = 0 ) OR ( lHeight = 0 ) then
     begin
       lWidth := 640;
       lHeight := 480;
     end;


    {************************************************************}
    {* get screen height and width                              *}
    {************************************************************}

    IF PaneWindow.hwndFrame <> NULLHANDLE THEN BEGIN
        WinSetWindowPos(PaneWindow.hwndFrame,
                      NULLHANDLE,
                      lWidth div 8,
                      lHeight div 8,
                      lWidth div 8*6,
                      lHeight div 8*6,
                      SWP_SIZE OR SWP_MOVE OR SWP_ACTIVATE OR SWP_SHOW);
        (**WinSetWindowPostoolbaȑȂ**)

        WHILE WinGetMsg(habAnchor,qmMsg,NULLHANDLE,0,0) DO BEGIN
            WinDispatchMsg( habAnchor,qmMsg);
        END;
        WinDestroyWindow(PaneWindow.hwndFrame);
    END;
    WinDestroyMsgQueue(hmqQueue);
    WinTerminate(habAnchor);
END.


@


3.3
log
@萔ς
@
text
@d15 1
a15 1
    MainItem:ARRAY [0..5] OF ToolbarData=(
d17 2
a18 2
            (NuID:IDB_FILEOPEN;cText:' Open existing file '),
            (NuID:IDB_FILESAVE;cText:' Save file '),
d54 1
d122 1
d149 2
a150 3
       IF Fy mod 40 =0 then begin
            WinPostMsg(ClientThreadWnd,WM_RePaint,mparam(0),mparam(0));
       end;
@


3.2
log
@Ƃ肠ArtifyɓꍞނƂ͐
@
text
@d164 1
a164 1
    BitmapFilter:=BitmapFilterClass.Create(640,480);
@


3.1
log
@*** empty log message ***
@
text
@d4 3
a6 1
os2def,os2base,os2pmapi,Widget,uGetOpt,SysUtils,ArtUnit,VPUtils;
d24 4
a27 2
      DefaultMenuExp=1;
      DefaultMenuStep=8;
d30 3
d35 1
a42 1
        MenuExp,MenuStep:integer;
d49 1
d58 1
a58 1
PROCEDURE ActiveSubMenu(hwndFrame:hwnd;ID_Menu,ID_Sub,id:ULONG;Active:BOOLEAN);
d60 3
a62 3
    hwndMenu,hwndSubMenu:HWnd;
    mi:MenuItem;
    rc:MResult;
d64 56
a119 23
    hwndMenu:=WinWindowFromID(hwndFrame,FID_MENU);
    WinSendMsg(hwndMenu,                  //* j[Eo[̃nh */
         MM_QUERYITEM,                    //* bZ[W        @@@@@@ */
         MPFROM2SHORT(ID_Menu, 1),    //* Tuj[ ID          */
         MParam(@@mi));                    //* MENUITEM w|C^[  */
    hwndSubMenu := mi.hwndSubMenu;       //* Tuj[̃nh   */

    WinSendMsg(hwndSubMenu,                  //* j[Eo[̃nh */
         MM_QUERYITEM,                    //* bZ[W        @@@@@@ */
         MPFROM2SHORT(ID_Sub, 1),    //* Tuj[ ID          */
         MParam(@@mi));                    //* MENUITEM w|C^[  */
    hwndSubMenu := mi.hwndSubMenu;       //* Tuj[̃nh   */

    IF Active THEN
        rc:=WinSendMsg(hwndSubMenu,
                   MM_SETITEMATTR,
                   MPFROM2SHORT(Id,1),
                   MPFROM2SHORT(MIA_CHECKED,MIA_CHECKED) )
    ELSE
        rc:=WinSendMsg(hwndSubMenu,
                   MM_SETITEMATTR,
                   MPFROM2SHORT(Id,1),
                   MPFROM2SHORT(MIA_CHECKED,Ord(FALSE)) );
d121 18
d142 3
a144 1
constructor BitmapFilterClass.Create(x,y:integer);
d146 10
a155 2
    ViewGraph:=GraphDataClass.Create;
    ViewGraph.SetupHeader(x,y);
d158 1
a158 4
procedure BitmapFilterClass.RunFilter;
begin
    ViewGraph.Artify;
end;
d164 1
a164 2
    MenuExp:=DefaultMenuExp;MenuStep:=DefaultMenuStep;
    BitmapFilter:=BitmapFilterClass.Create(320,240);
d187 8
a200 2
         //           RunArt;
           //         WinInvalidateRect(window,nil,false);
d202 1
a202 1
                IDB_EXIT:begin
a203 1
                end;
a205 5
        wm_EndThread:begin
            DosKillThread(ArtfyThread);
            isOnFilter:=FALSE;
            WinInvalidateRect(window,NIL,FALSE);
        end;
@
